Fapi_AuthorizePolicy
Feature API

## Functions

TSS2_RC | Fapi_AuthorizePolicy (FAPI_CONTEXT *context, char const *policyPath, char const *keyPath, uint8_t const *policyRef, size_t policyRefSize)
TSS2_RC | Fapi_AuthorizePolicy_Async (FAPI_CONTEXT *context, char const *policyPath, char const *keyPath, uint8_t const *policyRef, size_t policyRefSize)
TSS2_RC | Fapi_AuthorizePolicy_Finish (FAPI_CONTEXT *context)

## Detailed Description

FAPI functions to invoke AuthorizePolicy either as one-call or in an asynchronous manner.

## Function Documentation

## Fapi_AuthorizePolicy()

TSS2_RC Fapi_AuthorizePolicy | ( | FAPI_CONTEXT * | context,
|  | char const * | policyPath,
|  | char const * | keyPath,
|  | uint8_t const * | policyRef,
|  | size_t | policyRefSize )

One-Call function for Fapi_AuthorizePolicy

If a current policy happens to be a PolicyAuthorize, then for it to be used, the user must first satisfy a policy authorized by a having been signed (and made into a ticket) by an authorized party.

Parameters

  [in,out] | context | The FAPI context
  [in] | policyPath | The path to the policy file
  [in] | keyPath | The path to the signing key
  [in] | policyRef | A byte buffer that is included in the signature. May be NULL
  [in] | policyRefSize | The size of policyRef. Must be 0 if policyRef is NULL

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context, policyPath or keyPath is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_PATH | if policyPath or keyPath does not map to a FAPI policy or key object.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_TRY_AGAIN | if an I/O operation is not finished yet and this function needs to be called again.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if a key was not found.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.

## Fapi_AuthorizePolicy_Async()

TSS2_RC Fapi_AuthorizePolicy_Async | ( | FAPI_CONTEXT * | context,
|  | char const * | policyPath,
|  | char const * | keyPath,
|  | uint8_t const * | policyRef,
|  | size_t | policyRefSize )

Asynchronous function for Fapi_AuthorizePolicy

If a current policy happens to be a PolicyAuthorize, then for it to be used, the user must first satisfy a policy authorized by a having been signed (and made into a ticket) by an authorized party.

Call Fapi_AuthorizePolicy_Finish to finish the execution of this command.

Parameters

  [in,out] | context | The FAPI context
  [in] | policyPath | The path to the policy file
  [in] | keyPath | The path to the signing key
  [in] | policyRef | A byte buffer that is included in the signature. May be NULL
  [in] | policyRefSize | The size of policyRef. Must be 0 if policyRef is NULL

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context, policyPath or keyPath is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_PATH | if policyPath or keyPath does not map to a FAPI policy or key object.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.

## Fapi_AuthorizePolicy_Finish()

TSS2_RC Fapi_AuthorizePolicy_Finish | ( | FAPI_CONTEXT * | context | ) |

Asynchronous finish function for Fapi_AuthorizePolicy

This function should be called after a previous Fapi_AuthorizePolicy_Async.

Parameters

  [in,out] | context | The FAPI_CONTEXT

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_TRY_AGAIN | if the asynchronous operation is not yet complete. Call this function again later.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if a key was not found.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.